package ServerConfig;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;

/**
 * @author Min Huang (khtwo)
 * Start the central naming service
 */
public class StartCentralServer {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		ServerConfig currentConfig = new ServerConfig();
		// Read and parse configuration
		try {
			currentConfig.readNSFromFile();
		}
		catch (Exception ex) {
			System.out.println("Can not read central naming service information, quit");
			Runtime.getRuntime().exit(1);
		}

		// Start central Naming Service on current host
		try {
			System.out.println("Starting Central Naming Service");
			Runtime.getRuntime().exec(
					"cmd /c start orbd -port " + ServerConfig.centralNCPort + " -ORBInitialPort "
							+ ServerConfig.centralNCInitialPort + " -ORBInitialHost "
							+ ServerConfig.centralNCInitialHost);
			System.out.println("Central Naming Service Started.");
		}
		catch (Exception ex) {
			System.out.println("Central Naming Service starting failed.");
		}

	}

}
