package BankServer;

import BankServer.BankImpl;
import BankApp.*;
import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;
import org.omg.PortableServer.*;
import org.omg.PortableServer.POA;
import java.util.Properties;
import org.omg.CORBA.ORB.*;
import org.omg.CORBA.*;
import java.net.*;


public class BankServer
{
	
	//public static String branchHostNames[]={"chile", "uruguay", "argentina"};
	public static int myBranchNo; 
	
	//public static String myHostName;
	public static NamingContextExt ncRef;
	public static void main(String args[]) 
	{		
		try
		{
			if (args.length<5)
			{
				System.out.println("usage: BankServer.BankServer [branch number]");
				return ;
			}
			myBranchNo=Integer.parseInt(args[4]);
			//myHostName=BankUtility.getHostName();
			
			//inetSocketAddress=new InetSocketAddress(5000);


			//System.out.println("host name is" +inetSocketAddress.getHostName());

			// create and initialize the ORB
			ORB orb = ORB.init(args, null);
			// get reference to rootpoa& activate the POAManager
			POA rootpoa= (POA)orb.resolve_initial_references("RootPOA");

			rootpoa.the_POAManager().activate();
			
			// create servant and register it with the ORB
			BankImpl bankImpl= new BankImpl(myBranchNo);
			bankImpl.setORB(orb);

			// get object reference from the servant
			org.omg.CORBA.Object ref =
				rootpoa.servant_to_reference(bankImpl);

			// and cast the reference to a CORBA reference
			Bank href= BankHelper.narrow(ref);


			// get the root naming context
			// NameServiceinvokes the transient name service
			org.omg.CORBA.Object objRef=orb.resolve_initial_references("NameService");

			//now create a pointer to namecontext

			//NamingContext namingContext=objRef;

			ncRef= NamingContextExtHelper.narrow(objRef);
			// bind the Object Reference in Naming

			//String name = "Branch" + args[4];
			//String port="1234";
			//NameComponent path[]  = ncRef.to_name( name );
			//ncRef.rebind(path, href);

			

			//serverSocket=new ServerSocket(BankUtility.BasePortNumber);				
			/*//this is for test
			
			branchHostNames=new String[BankUtility.MaxBranchNumber];
			
			for (int i=0; i<BankApp.BankUtility.MaxBranchNumber; i++)
			{				
				branchHostNames[i]="unknown";
			}
			*/
			registerInfo(ncRef, href);

			// Use NamingContextExt, which is part of the
			// Interoperable Naming Service (INS) specification.
	
			System.out.println("Branch"+myBranchNo+ " Server ready and waiting ...");

			// wait for invocations from clients
			orb.run();
		}
		catch(Exception er)
		{
			System.out.println("error");
			System.out.println(er.getMessage());
		}
	}

	public static void clearHostName(NamingContextExt ncRef, int myBranchNo)
	{
		BindingListHolder bl=new BindingListHolder();
		BindingIteratorHolder bh=new BindingIteratorHolder();

		ncRef.list(50, bl, bh);
		Binding bindings[]=bl.value;
		NameComponent nc[];//=n[0].binding_name;
		//for (int i=0; i<n.length; i++)
		
		//ncRef.unbind(test);
		for (int i=0; i<bindings.length; i++)			
		{			
			//System.out.println("loop for " + i);				
			if (bindings[i].binding_type==BindingType.ncontext)
			{
				nc=bindings[i].binding_name;			
				for (int j=0; j<nc.length; j++)
				{						
					if (nc[j].kind.compareTo("host"+Integer.toString(myBranchNo))==0)
					{						
						try
						{
							System.out.println("try to unbind "+ "host"+Integer.toString(myBranchNo));
							ncRef.unbind(nc);
							//ncRef.resolve(nc[j]);
						}
						catch (Exception er)
						{
							System.out.println("unbind error in clear host name"+nc[j].id);
						}
					}
					
				}
			}
		}		
		
	}

	protected static void registerInfo(NamingContextExt ncRef,  Bank bank)
	{
		InetAddress inetAddress;
		ServerSocket serverSocket;
		
		try
		{					
			//clearHostName(ncRef, myBranchNo);
			serverSocket=new ServerSocket(9000);
			//System.out.println("why?");
			inetAddress=serverSocket.getInetAddress();
			//System.out.println("hostname="+ inetAddress.getLocalHost().getHostName());
			//branchHostNames[myBranchNo-100]=inetAddress.getLocalHost().getHostName();
			serverSocket.close();
			
			NamingContextExt bankContext=ncRef;
			
			//NameComponent branchNC[]=ncRef.to_name("Branch"+branchNo);
			//NamingContextExt branchCtx=(NamingContextExt)ncRef.bind_new_context(branchNC);
			

			//NameComponent hostNode= new NameComponent(branchHostNames[myBranchNo-100], "host"+ myBranchNo);
			//NameComponent hostDir[]={hostNode};
			//bankContext.rebind_context(hostDir, bankContext);

			NameComponent path[]  = bankContext.to_name("Branch"+myBranchNo);
			//ncRef.rebind(path, bank);
			//bankContext.rebind_context(hostDir, bankContext);
			ncRef.rebind(path, bank);

			/*
			try
			{
				
				bankContext.unbind(hostDir);
				
			}
			catch(Exception er)
			{
				System.out.println("cannot unbind "+hostDir.toString());
				bankContext.rebind_context(hostDir, bankContext);
			}
			

			try
			{
				ncRef.unbind(path);
			}
			catch (Exception er)
			{
				System.out.println("cannot unbind "+path.toString());
				ncRef.rebind(path, bank);
			}
			*/


			
			
			
			//ncRef.rebind(path, ncRef);

			/*

			NameComponent branchNode=new NameComponent("Branch" + Integer.toString(branchNo), "branch");
			NameComponent branchDir[]={branchNode};

			
			NamingContext branchContext=bankContext.bind_new_context(branchDir);
			
			NameComponent bankNode=new NameComponent("Branch"+Integer.toString(branchNo), "interface");

			NameComponent rootNode=new NameComponent("BankInterface", "root");

			NameComponent rootDir[]={rootNode};
			NameComponent bankDir[]={bankNode};

			branchContext.bind(bankDir, bank);

			
			NameComponent portNode= new NameComponent(Integer.toString(BasePortNumber+branchNo), "port");
			NameComponent portDir[]={portNode};

			branchContext.bind(portDir, branchContext);

			NameComponent hostNode= new NameComponent("localhost", "host");
			NameComponent hostDir[]={hostNode};

			branchContext.bind(hostDir, branchContext);
			*/
		}
		catch (Exception er)
		{
			System.out.println("error in create");
			System.out.println(er.getMessage());
		}
	}


}
				