package BankServer;

import java.net.*;
import java.io.*;
import BankApp.*;
import BankApp.Packet;
import BankApp.BankUtility.*;

//import java.io.ByteArrayInputStream;
//import java.io.DataInputStream;



public class UDPClientSocket extends UDPSocket
{
	protected int replyPortNumber;//27000

	public UDPClientSocket()
	{
		replyPortNumber=BankUtility.BaseReplyPortNumber;
		try
		{
			sendSocket=new DatagramSocket();			
		}
		catch (Exception er)
		{
			System.out.println(er.getMessage());
		}
				//don't initialize recv socket because it is dynamic 
	}

	//must always timeout, otherwise we cannot retry other host name when primary fails
	//the sender who create packet is responsible to write down the host index in packet
	public void sendPacket(String hostName, int portNumber, Packet packet)	throws Exception
	{			
		Packet result;
		int counter=0;
		int index;
		
		index= getIndexByName(hostName, portNumber);
		if (index==-1)
		{
			index=connectionCount;
			connectionCount++;
			hostNames[index]=hostName;
			portNumbers[index]=portNumber;
			seqNumber[index]=0;
		}
					
		//System.out.println("client call and index="+index);
	
		
		
		packet.seqNumber=seqNumber[index];

		/* Depreciated, corrected by khtwo, use the code followed
		boolean done;
		do
		{
			done=true;
			replyPortNumber++;
			if (replyPortNumber==BankUtility.MaxReplyPortNumber)
			{
				replyPortNumber=BankUtility.BaseReplyPortNumber;
			}
			try
			{
				recvSocket=new DatagramSocket(replyPortNumber);		
			}
			catch (Exception er)
			{				
				done=false;
			}
		}
		while (!done);
		*/
		
		// Use the send socket directly
		replyPortNumber = sendSocket.getLocalPort();
		recvSocket = sendSocket;
		

		packet.tag=replyPortNumber;//must indicate the reply port number		
		//think it over
		do
		{
			try
			{
				// debug
				BankUtility.showDebugInfo(2,"Send packet to " + hostName + ":" + portNumber);
				recvSocket.setSoTimeout(BankUtility.TimeOutMiliSeconds);

				doSendPacket(hostName, portNumber, packet);
			
				do
				{
					//must setup the receive port number
					//every time when it is not what I expect, I reset the timeout
					result=doRecvPacket();

					// debug
					BankUtility.showDebugInfo(2,"Received reply from "+recvPacket.getAddress().getHostAddress()+":"+recvPacket.getPort());

				}
				while (result.status!=BankUtility.ACKNOWLEDGEMENT||result.seqNumber!=seqNumber[index]);
				//now step to new seq number
				seqNumber[index]=result.seqNumber+1;				
				
				return;
			}
			catch (Exception er)
			{
				// Error in communication, add the error counter
				counter++;	
			}			
			finally
			{
				// Error correction, should not close here
				//recvSocket.close();//better to clear this port number resource for re-usage
			}
			
		}while (counter<BankUtility.MaxTrialNumber);
		
		if (counter >= BankUtility.MaxTrialNumber) {
			// recvSocket.close();
			throw new ConnectException();
		}
	}	
}
