package BankServer;

import java.net.*;
import java.io.*;
import BankApp.*;
import BankApp.Packet;
import BankApp.BankUtility.*;

//import java.io.ByteArrayInputStream;
//import java.io.DataInputStream;



public class UDPDialogClient extends UDPSocket
{
	
	public Packet sendPacket(String hostName, int portNumber, Packet packet) throws Exception
	{
		Packet result=null;
		
		int counter=0;
		int index;
		
		index= getIndexByName(hostName, portNumber);
		if (index==-1)
		{
			index=connectionCount;
			connectionCount++;
			hostNames[index]=hostName;
			portNumbers[index]=portNumber;
			seqNumber[index]=0;
		}			
		
		packet.seqNumber=0;

		boolean done;
		do
		{
			done=true;
			replyPortNumber++;
			if (replyPortNumber==BankUtility.MaxReplyPortNumber)
			{
				replyPortNumber=BankUtility.BaseReplyPortNumber;
			}
			try
			{
				
				recvSocket=new DatagramSocket(replyPortNumber);		
			}
			catch (Exception er)
			{				
				done=false;
			}
		}
		while (!done);

		packet.tag=replyPortNumber;//must indicate the reply port number		
		//think it over
		do
		{
			try
			{
				System.out.println("before send out packet");
				packet.display();
				doSendPacket(hostName, portNumber, packet);		
			
				do
				{
					//must setup the receive port number
					//every time when it is not what I expect, I reset the timeout
					recvSocket.setSoTimeout(BankUtility.TimeOutMiliSeconds);
					result=doRecvPacket();
					System.out.println("\nclient receive ackn   ");
					result.display();
					System.out.println("\n\n");
				}
				while (result.status!=BankUtility.ACKNOWLEDGEMENT||result.seqNumber!=seqNumber[index]);
				//now step to new seq number
				//seqNumber[index]=result.seqNumber+1;

				do
				{
					//must setup the receive port number
					//every time when it is not what I expect, I reset the timeout
					recvSocket.setSoTimeout(BankUtility.TimeOutMiliSeconds);
					result=doRecvPacket();
					System.out.println("\nclient receive ackn   ");
					result.display();
					System.out.println("\n\n");
				}
				while (result.status!=BankUtility.REPLY||result.seqNumber!=seqNumber[index]);
				
				//recvSocket.close();				
			}
			catch (Exception er)
			{
				counter++;	
				if (er instanceof SocketException)
				{									
					if (counter==BankUtility.MaxTrialNumber)
					{
						throw er;
					}
				}
				else
				{
					System.out.println("unknown error in sendPacket "+er.getMessage());
				}
			}			
			finally
			{
				
				//recvSocket.close();//better to clear this port number resource for re-usage
				return result;
			}
			
		}while (counter<BankUtility.MaxTrialNumber);
	}



	//if we are going to monitor incoming message, there is no timeout,
	//if we are acknowledge receipt, we must have this timeout, otherwise
	//system maybe deadlock
	public synchronized Packet recvPacket() 
	{
		Packet result=null;
		//disable timeout functionality
		int index;
		try
		{	
			do
			{		
				//recvSocket=new DatagramSocket(myPortNumber);
				recvSocket.setSoTimeout(0);
				result=doRecvPacket();
				
				String theHostName=recvPacket.getAddress().getHostName();
				int thePortNumber=recvPacket.getPort();
				index= getIndexByName(theHostName, thePortNumber);
				if (index==-1)
				{
					//this is a new connection
					index=connectionCount;
					connectionCount++;
					hostNames[index]=theHostName;
					portNumbers[index]=thePortNumber;
					seqNumber[index]=result.seqNumber;
				}
				//System.out.println("server call gethost by adddress and index="+ index);
				System.out.println("server call and index="+index);

				System.out.println("\nserver recieve one packet");
				result.display();
				System.out.println("\n\n");
			}
			while (result.seqNumber<seqNumber[index]);
			
			seqNumber[index]=result.seqNumber;
			Packet ack=new Packet();

			replyPortNumber=result.tag;
			replyHostName=recvPacket.getAddress().getHostName();
			
			ack.opID=result.opID;
			
			ack.seqNumber=result.seqNumber;
			/////////////////////////////////
			//BankUtility.ACKNOWLEDGEMENT;

			ack.status=BankUtility.ACKNOWLEDGEMENT;
			//make sure bankimplement has this 
			System.out.println("\nserver acknowledge ");
			ack.display();
			System.out.println("\n\n");
			doSendPacket(recvPacket.getAddress().getHostName(), replyPortNumber, ack);
			//System.out.println("server acknowledge OK");
		}
		catch (Exception er)
		{
			System.out.println("unknown error in recvPacket "+ er.getMessage());
		}
		finally
		{
			return result;		
		}
	}


	//use the previous reply portnumber
	public synchronized void replyPacket(Packet packet) throws Exception
	{
		sendPacket(replyHostName, replyPortNumber, packet);
		recvSocket.close();
	}
		

} //end class







